package com.netiq.nam.oauth.authz_sample.app.debug;

import com.google.api.client.auth.oauth2.StoredCredential;
import com.netiq.nam.oauth.helpers.Http;
import com.netiq.nam.oauth.helpers.OAuth2Helper;
import com.netiq.nam.oauth.helpers.OAuth2Properties;
import com.netiq.nam.oauth.helpers.Token;
import com.netiq.nam.oauth.servlets.AuthorizationCallback;
import com.netiq.nam.oauth.servlets.OAuth2ProtectedServlet;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * Created by tsureshkumar on 12/7/14.
 */
public class ValidateTokenServlet extends OAuth2ProtectedServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        StoredCredential credential = OAuth2Helper.getInstance().getCredential(req.getSession().getId());
        Token token = new Http().insecureGet(OAuth2Properties.tokenInfoEndpoint(), credential.getAccessToken()).parseAs(Token.class);
        if (token != null) {
            req.getSession(true).setAttribute(AuthorizationCallback.USER_ID, token.getUser());
            req.getSession(true).setAttribute(AuthorizationCallback.OAUTH_2_TOKEN, token);
        } else {
            resp.sendError(500);
            resp.getWriter().write("error getting token info");
            return;
        }
        req.setAttribute("token", token);
        req.getRequestDispatcher("/validate.jsp").include(req, resp);
    }
}
