package com.netiq.nam.oauth.app;

import com.netiq.nam.oauth.helpers.OAuth2Protected;

import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.SecurityContext;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

/**
 * Created by tsureshkumar on 12/7/14.
 */
@Path("todos")
public class TodoResource {
    // simple store to hold user --> List of tasks for that user
    private static HashMap<String, List<Task>> todoList = new HashMap<>();

    @GET
    @OAuth2Protected
    @Produces(MediaType.APPLICATION_JSON)
    public List<Task> getMyTasks(@Context SecurityContext securityContext) {
        if (securityContext == null)
            return Collections.emptyList();

        List<Task> tasks = todoList.get(securityContext.getUserPrincipal().getName());
        if (tasks == null)
            return Collections.emptyList();
        return tasks;
    }

    @POST
    @OAuth2Protected
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public List<Task> addTask(
            List<Task> task,
            @Context SecurityContext securityContext) {
        if (securityContext == null)
            return Collections.emptyList();

        String name = securityContext.getUserPrincipal().getName();
        List<Task> tasks = todoList.get(name);
        if (tasks == null) {
            tasks = new ArrayList<>();
            todoList.put(name, tasks);
        }
        tasks.addAll(task);
        return tasks;
    }

}
