import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.api.client.auth.oauth2.ClientCredentialsTokenRequest;
import com.google.api.client.auth.oauth2.ClientParametersAuthentication;
import com.google.api.client.auth.oauth2.PasswordTokenRequest;
import com.google.api.client.auth.oauth2.TokenResponse;
import com.google.api.client.http.GenericUrl;
import com.google.api.client.http.HttpResponse;
import javafx.scene.layout.VBox;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.*;
import java.util.stream.Collectors;

/**
 * Created by tsureshkumar on 8/27/14.
 */
public class Main {


    public static void main(String[] args) {

        final JFrame win = new JFrame("RO Sample");
        win.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        win.setSize(new Dimension(300, 500));
        win.setLayout(new BorderLayout());

        Box vbox;
        win.add(vbox = Box.createVerticalBox(), BorderLayout.CENTER);

        Box controlBox;
        Box ubox;
        win.add(controlBox = Box.createVerticalBox(), BorderLayout.PAGE_START);

        controlBox.add(ubox = Box.createHorizontalBox());
        final JTextField txtUsername;
        final JPasswordField txtPassword;
        ubox.add(new JLabel("Username:"));
        ubox.add(txtUsername = new JTextField("alice"));
        ubox.add(new JLabel("Password:"));
        ubox.add(txtPassword = new JPasswordField("novell"));

        controlBox.add(ubox = Box.createHorizontalBox());
        ubox.add(new JLabel("Scopes (space seperated):"));
        final JTextField txtScopes;
        ubox.add(txtScopes = new JTextField("email profile"));


        controlBox.add(ubox = Box.createHorizontalBox());
        JButton btn;
        ubox.add(btn = new JButton("Get User Details"));
        JButton btnTokenDetails;
        ubox.add(btnTokenDetails = new JButton("Get Token Details"));


        JPanel frame;
        vbox.add(frame = new JPanel());
        frame.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
        frame.setSize(new Dimension(300, 200));
        final JLabel lbl;
        frame.add(lbl = new JLabel());

        win.show();

        final Properties properties = NAMOAuthHelper.loadProperties();
        final TokenResponse[] response = {null};

        btn.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                PasswordTokenRequest request = new PasswordTokenRequest(NAMOAuthHelper.TRANSPORT,
                        NAMOAuthHelper.JSON_FACTORY,
                        new GenericUrl(properties.getProperty("token_endpoint")),
                        txtUsername.getText(),
                        new String(txtPassword.getPassword())
                )
                        .setScopes(Arrays.asList(txtScopes.getText().split(" ")))
                        .setClientAuthentication(new ClientParametersAuthentication(properties.getProperty("client_id"),
                                properties.getProperty("client_secret")));

                try {
                    response[0] = request.execute();
                    System.out.println(response[0].getAccessToken());
                    HttpResponse userResponse = NAMOAuthHelper.executeGet(NAMOAuthHelper.TRANSPORT,
                            NAMOAuthHelper.JSON_FACTORY,
                            response[0].getAccessToken(),
                            new GenericUrl(properties.getProperty("userinfo_endpoint")));
                    String value = userResponse.parseAsString();
                    ObjectMapper mapper = new ObjectMapper();
                    value = mapper.writerWithDefaultPrettyPrinter().writeValueAsString(mapper.readValue(value, Object.class));
                    String html = "<html><pre>" + value + "</pre></html>";
                    System.out.println(html);
                    lbl.setText(html);

                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        });

        btnTokenDetails.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(response[0] == null) {
                    JOptionPane.showMessageDialog(win, "No Token Info available");
                }
                TokenResponse resp = response[0];
                HttpResponse userResponse = null;
                try {
                    userResponse = NAMOAuthHelper.executeGet(NAMOAuthHelper.TRANSPORT,
                            NAMOAuthHelper.JSON_FACTORY,
                            response[0].getAccessToken(),
                            new GenericUrl(properties.getProperty("tokeninfo_endpoint")));
                    String value = userResponse.parseAsString();
                    ObjectMapper mapper = new ObjectMapper();
                    value = mapper.writerWithDefaultPrettyPrinter().writeValueAsString(mapper.readValue(value, Object.class));
                    String html = "<html><pre>" + value + "</pre></html>";
                    System.out.println(html);
                    lbl.setText(html);
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        });

    }
}
